The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Delay Class Reference

STK non-interpolating delay line class. More...

`#include <Delay.h>`

Inheritance diagram for stk::Delay:

List of all members.

## Public Member Functions
| Delay (unsigned long delay=0, unsigned long maxDelay=4095)
| The default constructor creates a delay-line with maximum length of 4095 samples and zero delay.
| ~Delay ()
| Class destructor.
unsigned long | getMaximumDelay (void)
| Get the maximum delay-line length.
void | setMaximumDelay (unsigned long delay)
| Set the maximum delay-line length.
void | setDelay (unsigned long delay)
| Set the delay-line length.
unsigned long | getDelay (void) const
| Return the current delay-line length.
StkFloat | tapOut (unsigned long tapDelay)
| Return the value at tapDelay samples from the delay-line input.
void | tapIn (StkFloat value, unsigned long tapDelay)
| Set the value at tapDelay samples from the delay-line input.
StkFloat | addTo (StkFloat value, unsigned long tapDelay)
| Sum the provided value into the delay line at tapDelay samples from the input.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | nextOut (void)
| Return the value that will be output by the next call to tick().
StkFloat | energy (void) const
| Calculate and return the signal energy in the delay-line.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK non-interpolating delay line class.

This class implements a non-interpolating digital delay-line. If the delay and maximum length are not specified during instantiation, a fixed maximum length of 4095 and a delay of zero is set.

A non-interpolating delay line is typically used in fixed delay-length applications, such as for reverberation.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Delay::Delay | ( | unsigned long | delay = `0`,
|  | unsigned long | maxDelay = `4095` |
| ) |  |  |

The default constructor creates a delay-line with maximum length of 4095 samples and zero delay.

An StkError will be thrown if the delay parameter is less than zero, the maximum delay parameter is less than one, or the delay parameter is greater than the maxDelay value.

## Member Function Documentation

void stk::Delay::setMaximumDelay | ( | unsigned long | delay | ) |

Set the maximum delay-line length.

This method should generally only be used during initial setup of the delay line. If it is used between calls to the tick() function, without a call to clear(), a signal discontinuity will likely occur. If the current maximum length is greater than the new length, no memory allocation change is made.

void stk::Delay::setDelay | ( | unsigned long | delay | ) |

Set the delay-line length.

The valid range for delay is from 0 to the maximum delay-line length.

StkFloat stk::Delay::tapOut | ( | unsigned long | tapDelay | ) |

Return the value at tapDelay samples from the delay-line input.

The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero returns the last input value).

StkFloat stk::Delay::addTo | ( | StkFloat | value,
|  | unsigned long | tapDelay |
| ) |  |  |

Sum the provided value into the delay line at tapDelay samples from the input.

The new value is returned. The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero sums into the last input value).

StkFloat stk::Delay::nextOut | ( | void |  | ) | `[inline]`

Return the value that will be output by the next call to tick().

This method is valid only for delay settings greater than zero!

    00087 { return inputs_[outPoint_]; };

StkFrames & stk::Delay::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00142 {
    00143 #if defined(_STK_DEBUG_)
    00144   if ( channel >= frames.channels() ) {
    00145     oStream_ << "Delay::tick(): channel and StkFrames arguments are incompatible!";
    00146     handleError( StkError::FUNCTION_ARGUMENT );
    00147   }
    00148 #endif
    00149
    00150   StkFloat *samples = &frames[channel];
    00151   unsigned int hop = frames.channels();
    00152   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00153     inputs_[inPoint_++] = *samples * gain_;
    00154     if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
    00155     *samples = inputs_[outPoint_++];
    00156     if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
    00157   }
    00158
    00159   lastFrame_[0] = *(samples-hop);
    00160   return frames;
    00161 }

StkFrames & stk::Delay::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00164 {
    00165 #if defined(_STK_DEBUG_)
    00166   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00167     oStream_ << "Delay::tick(): channel and StkFrames arguments are incompatible!";
    00168     handleError( StkError::FUNCTION_ARGUMENT );
    00169   }
    00170 #endif
    00171
    00172   StkFloat *iSamples = &iFrames[iChannel];
    00173   StkFloat *oSamples = &oFrames[oChannel];
    00174   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00175   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
    00176     inputs_[inPoint_++] = *iSamples * gain_;
    00177     if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
    00178     *oSamples = inputs_[outPoint_++];
    00179     if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
    00180   }
    00181
    00182   lastFrame_[0] = *(oSamples-oHop);
    00183   return iFrames;
    00184 }

The documentation for this class was generated from the following file:

- Delay.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.